s         ::=  Grammar ws                  => "gram"
ws       !::=  w** | w** "//" (~[\n]*) "\n" ws
wp       !::=  w++
Grammar   ::=  r +/ ws                        => "grammar"

r         ::=  word  ^"::=" alternatives /ws
            |  word ^"!::=" alternatives /ws

alternatives  ::=  (Conjuncts +/ (ws "|" ws)) +/ (ws ">" ws)

Conjuncts     ::=  Sequence
                |  Sequence ^"&"  e*/ws   /ws
                |  Sequence ^"&~" e*/ws   /ws

ps         ::= e*/ws                              => "ps"
             | (e+/ws ws)? "^" Quoted (ws e+/ws)? => "ps2"
psy        ::= ps
             | ps wp ^"/" ws e
psx        ::= psy                   => "psy"
//             | e "<-" psy        /ws => "psyl"
             |        psy "->" e /ws => "psyr"
//             | e "<-" psy "->" e /ws => "psylr"
Sequence   ::= Quoted => "qprod"
             > psx
             | psx  "=>" ^"[]"         /ws
             | psx ^"=>" (word|Quoted) /ws

ec       ::= ~[\-\]\\]
           | escaped

Range    ::= ec          => "range"
           | ec ^"-" ec

e        ::=  word                          => "nonTerminal"
           |  Quoted                        => "literal"
           |    ^"()"
           |    ^"{" Sequence "}"       /ws
           |    ^"["  Range* "]"

           |  (e ^"++"    /ws > e ^"+"    /ws)
           |  (e ^"++/" e /ws > e ^"+/" e /ws)
           |  (e ^"**"    /ws > e ^"*"    /ws)
           |  (e ^"**/" e /ws > e ^"*/" e /ws)
           |  e ^"?"                    /ws

           |     "(" word         ^")"  /ws
           >    ^"(" alternatives  ")"  /ws
           |    ^"~" e

w       !::= " "
           | "\n"
           | "\r"
word     ::= [a-zA-Z0-9_]++
Quoted   ::= "\"" ((~[\"\\] | escaped)+) "\""
           | "\"\"" => ""
escaped  ::= "\\n" => "\n"
           | "\\r" => "\r"
           | "\\" ~[nr]


